unit stdInt;

{$MESSAGE 'lėp샆jbg Ver 1.7'}
interface
uses
  Math,types;
  function  MappingInt  (const AValue,OldMax,NewMax:Integer): Integer;
  function  ReverseInt  (const AValue,AEnd:Integer): Integer;
  function  CenterItem  (const AWidth,AContentWidth:Integer): Integer;
  function  msToMinSec  (const MilliSecond:Cardinal;var Min,Sec:Byte): Integer;
  function  InRange2D   (const X,Y:Integer;const Range:TRect): Boolean;
  function  Make64      (const High,Low:Cardinal): Int64;
  procedure ZoomRect    (var Rect:TRect;X,Y:Integer);
  function  IsRandom    : Boolean;

implementation
/////////////////////////
// @ꂫ@
/////////////////////////
// 1.0...MappingInt֐ǉ
// 1.1...IncParam,CenterItem֐ǉ
// 1.2...IncParam֐p~,ReverseInt֐ǉ
// 1.3...msToMinSec֐ǉ
// 1.4...InRange2D֐ǉ
// 1.5...Make64֐ǉ
// 1.6...ZoomRect֐ǉ
// 1.7...IsRandom֐ǉ

function MappingInt(const AValue,OldMax,NewMax:Integer):Integer;
begin
  if (AValue = 0) or (OldMax = NewMax) then
    Result:= AValue
  else if OldMax > NewMax then
    Result:= AValue * Ceil(NewMax / OldMax)
  else
    Result:= Ceil(AValue / (OldMax / NewMax));
end;

function ReverseInt(const AValue,AEnd:Integer):Integer;
begin
  Result := (AValue - AEnd) * -1;
end;

function CenterItem(const AWidth,AContentWidth:Integer): Integer;
begin
  Result  := AWidth div 2 - AContentWidth div 2;
end;

function msToMinSec(const MilliSecond:Cardinal;var Min,Sec:Byte): Integer;
begin
  Min   := Trunc(MilliSecond / 1000 / 60);
  Sec   := Trunc(MilliSecond / 1000) - Min * 60;
  Result:= MilliSecond - Min * 60000 - sec * 1000;
end;

function InRange2D(const X,Y:Integer;const Range:TRect): Boolean;
begin
  with Range do
    Result := InRange(Y,Top,Bottom) and
      InRange(X,Left,Right);
end;

function Make64(const High,Low:Cardinal): Int64;
  //------------------------------------------------------------------------------
  // 232rbgl64rbgl
  // Highc32rbg
  // Lowc32rbg
  // ߂lcl
  //------------------------------------------------------------------------------
begin
  Result := Low + (High shl 32);
end;

procedure ZoomRect(var Rect:TRect;X,Y:Integer);
  //------------------------------------------------------------------------------
  // RectL
  // RectcύXRect
  // XcXɉL鐔l(k߂Ƃ͕)
  // YcYɉL鐔l(k߂Ƃ͕)
  //------------------------------------------------------------------------------
begin
  Dec(Rect.Left,X);
  Dec(Rect.Top,Y);
  Inc(Rect.Right,X);
  Inc(Rect.Bottom,Y);
end;

function IsRandom(): Boolean;
  //------------------------------------------------------------------------------
  // _TruekaFalseԂ܂B
  //------------------------------------------------------------------------------
const
  Rnd :array[0..1] of Integer= (0,1);
begin
  Result := RandomFrom(Rnd) = 1;
end;

end.

